﻿#pragma once
#include <iostream>
#include <thread>
#include <chrono>
#include <mutex>
#include <condition_variable>
#include <memory>
#include <future>
#include <cstdint>

typedef void (*ExitAppCallback)();

namespace mxnet2 {


    class License final {
        std::thread     m_waitThread;
        std::thread     m_loginThread;

        volatile bool   m_stop;
        bool            m_runUpdate;
        bool            m_errorExit;

        int32_t        m_userCode;
        int             m_interval;
        int16_t        m_appSlot;
        ExitAppCallback m_exitAppCallback;

	bool		m_sessionReleased;
	
        std::mutex                   mtx_wait;
        std::mutex                   mtx_loginUpdate;
        std::condition_variable      cv;
        std::condition_variable      cv2;

        void stopWaitThread();
        void stopUpdateThread();

        static bool getSync(int32_t usercode, int16_t appSlot);
        static void update(License* obj);
        static void WaitProc(License* obj);

    public:
        License(const License&) = delete;
        License& operator=(const License&) = delete;

        License(int32_t userCode, int16_t appSlot, int interval, ExitAppCallback callback);
        ~License();   

	bool setIp( const char* ip );
	bool setPort( int32_t port );
	void setUserCode( int32_t uc );
	
        bool get();

        void startUpdate();
        void stopUpdate();

    };
}
